package kaysaar.aotd_question_of_loyalty.data.scripts.trackers;

import com.fs.starfarer.api.campaign.comm.IntelInfoPlugin;
import com.fs.starfarer.api.Global;
import java.util.Iterator;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.impl.campaign.intel.events.EventFactor;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import kaysaar.aotd_question_of_loyalty.data.intel.eventfactors.onetime.MakingDeliveryFactor;
import com.fs.starfarer.api.impl.campaign.intel.BaseMissionIntel;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import com.fs.starfarer.api.impl.campaign.intel.bar.events.DeliveryMissionIntel;
import java.util.ArrayList;
import com.fs.starfarer.api.EveryFrameScript;

public class DeliveryTracker implements EveryFrameScript
{
    protected ArrayList<DeliveryMissionIntel> bountiesStored;
    
    public DeliveryTracker() {
        this.bountiesStored = new ArrayList<DeliveryMissionIntel>();
    }
    
    public boolean isDone() {
        return false;
    }
    
    public boolean runWhilePaused() {
        return false;
    }
    
    public void advance(final float amount) {
        for (final DeliveryMissionIntel bounty : this.getDeliveries()) {
            if (QoLMisc.isCommissionedBy(bounty.getFactionForUIColors().getId()) && !this.isAlreadyPresent(bounty)) {
                final BaseMissionIntel.MissionState state = bounty.getMissionState();
                if (state.equals((Object)BaseMissionIntel.MissionState.COMPLETED)) {
                    this.bountiesStored.add(bounty);
                    final int cash = bounty.getMissionResult().payment;
                    final int factor = cash / 5000;
                    AoTDCommIntelPlugin.addFactorCreateIfNecessary((EventFactor)new MakingDeliveryFactor(factor), (InteractionDialogAPI)null);
                }
                if (!state.equals((Object)BaseMissionIntel.MissionState.FAILED) && !state.equals((Object)BaseMissionIntel.MissionState.ABANDONED) && !state.equals((Object)BaseMissionIntel.MissionState.CANCELLED)) {
                    continue;
                }
                this.bountiesStored.add(bounty);
                final int cash = bounty.getMissionResult().payment;
                final int factor = cash / 30000;
                AoTDCommIntelPlugin.addFactorCreateIfNecessary((EventFactor)new MakingDeliveryFactor(-factor), (InteractionDialogAPI)null);
            }
        }
        final Iterator<DeliveryMissionIntel> iterator = this.bountiesStored.iterator();
        while (iterator.hasNext()) {
            final DeliveryMissionIntel baseCustomBounty = iterator.next();
            if (baseCustomBounty.isEnded()) {
                iterator.remove();
            }
        }
    }
    
    public ArrayList<DeliveryMissionIntel> getDeliveries() {
        final ArrayList<DeliveryMissionIntel> bounties = new ArrayList<DeliveryMissionIntel>();
        for (final IntelInfoPlugin intelInfoPlugin : Global.getSector().getIntelManager().getIntel((Class)DeliveryMissionIntel.class)) {
            if (intelInfoPlugin instanceof final DeliveryMissionIntel deliveryMissionIntel) {
                bounties.add(deliveryMissionIntel);
            }
        }
        return bounties;
    }
    
    public boolean isAlreadyPresent(final DeliveryMissionIntel bounty) {
        for (final DeliveryMissionIntel baseCustomBounty : this.bountiesStored) {
            if (bounty.getEvent().equals(baseCustomBounty.getEvent())) {
                return true;
            }
        }
        return false;
    }
}
